#pragma once

// Explanations about the defines and functions below are located in Datastead_Multipurpose_DirectShow_Encoder.pdf 

// http://www.datastead.com/products/dsfilters/multipurpose.html

//________________________________________________________________________________________________________
// DATASTEAD MULTIPURPOSE DIRECTSHOW ENCODER DEFINITIONS

#define EC_MPE_TERMINATED_SUCCESS EC_USER + 0x5501
#define EC_MPE_TERMINATED_ERROR   EC_USER + 0x5502
#define EC_MPE_LOGBUFFER_UPDATED  EC_USER + 0x5503

// {39E3007B-6185-47FC-9839-C4B8621AC065}
static const GUID CLSID_DatasteadMultipurposeDirectShowEncoder =
{ 0x39e3007b, 0x6185, 0x47fc, { 0x98, 0x39, 0xc4, 0xb8, 0x62, 0x1a, 0xc0, 0x65 } };

// {43F00ED1-5F85-4C7E-98AC-AD5E13111D34}
static const GUID IID_IDatasteadMultipurposeDirectShowEncoder =
{ 0x43f00ed1, 0x5f85, 0x4c7e, { 0x98, 0xac, 0xad, 0x5e, 0x13, 0x11, 0x1d, 0x34 } };

DECLARE_INTERFACE_(IDatasteadMultipurposeDirectShowEncoder, IUnknown)
{
	virtual HRESULT       STDMETHODCALLTYPE SetCommandLine(/*in*/ LPWSTR CommandLine) PURE;
	virtual HRESULT       STDMETHODCALLTYPE GetCommandLine(/*out*/ LPWSTR *CommandLine) PURE;
	virtual HRESULT       STDMETHODCALLTYPE Stop_PauseWhenStop() PURE;
	virtual HRESULT       STDMETHODCALLTYPE GetCurrentLog(/*in*/ bool OnlyIfUpdated, /*in*/ PCHAR pBuffer, /*in*/ int MaxBufferSize, /*out*/ int *CurrentLogSize, /*out*/ int *CurrentLogFlag) PURE;
	virtual HRESULT       STDMETHODCALLTYPE IsCurrentLogUpdated() PURE;
	virtual int           STDMETHODCALLTYPE GetExitCode() PURE;
	virtual unsigned int  STDMETHODCALLTYPE GetInputsTotalDurationMs() PURE;
	virtual unsigned int  STDMETHODCALLTYPE GetProgress_FrameCount() PURE;
	virtual unsigned int  STDMETHODCALLTYPE GetProgress_TimeMs() PURE;
	virtual unsigned int  STDMETHODCALLTYPE GetProgress_DuplicatedCount() PURE;
	virtual unsigned int  STDMETHODCALLTYPE GetProgress_DroppedCount() PURE;
	virtual double        STDMETHODCALLTYPE GetProgress_Fps() PURE;
	virtual double        STDMETHODCALLTYPE GetProgress_Quality() PURE;
	virtual double        STDMETHODCALLTYPE GetProgress_SizeWrittenKb() PURE;
	virtual double        STDMETHODCALLTYPE GetProgress_BitRateKbps() PURE;
	virtual HRESULT       STDMETHODCALLTYPE GetConnectedVideoPinInfo(/*out*/ int *VideoWidth, /*out*/ int *VideoHeight, /*out*/ int *VideoAvgTimePerFrame) PURE;
	virtual HRESULT       STDMETHODCALLTYPE GetConnectedAudioPinInfo(/*out*/ int *AudioChannels, /*out*/ int *AudioSampleRate, /*out*/ int *AudioBitsPerSample) PURE;
	virtual HRESULT       STDMETHODCALLTYPE SetMediaEventSinkNotifyID  (/*in*/ LONG_PTR Value) PURE;
	virtual BOOL          STDMETHODCALLTYPE Is64BitWindows() PURE;
	virtual BOOL          STDMETHODCALLTYPE Is64BitApplication() PURE;
};


